;-------- Beispiele fr Anwendung 80-Bit-FPU
;-------- "Helle" Klaus Helbing, 20.05.2007, PB4.02
;-------- bentigt das Include-File Procfpu80.pbi 

;- Var1, Var2 und Var3 PB als 10-Byte-Variable unterjubeln 
Structure FPU80Bit 
 Teil1.l : Teil2.l : Teil3.l ;jeweils 12 Byte reservieren, von Teil3 werden nur 2 Bytes genutzt
EndStructure 

Define.FPU80Bit Var1, Var2, Var3  ;dem Kind einen Namen geben

;- bentigten String fr die Bildschirm-Ausgabe definieren
Global Convert$ = Space(255) ;frei whlbarer Name fr die Ausgabe, Grsse je nach Bedarf (was man vor hat)

;- die 80-Bit-Prozeduren laden
XIncludeFile "Procfpu80.pbi" ;oder nur bentigte Prozeduren einfgen

;- Var1 und Var2 mit 10-Byte-Floating-Point-Werten belegen 
Teststring1$ = "0.75"
ValT(@Teststring1$, Var1)
Teststring2$ = "11"
ValT(@Teststring2$, Var2)

;- Ab hier Beispiele mit den beiden Variablen Var1 und Var2 
;-------- Beispiel ArcusCosinus(0.75)
ACosT(Var1, Var3)            ;Var3 = ACos(Var1) 
StrT(@Convert$, Var3)        ;liefert fr die Bildschirm-Ausgabe das Ergebnis als String (Convert$)
MessageRequester("Berechnungsbeispiel ACos(0.75)","Single-Float:   "+StrF(ACos(0.75),20)+#LFCR$+"Double-Float:  "+StrD(ACos(0.75),20)+#LFCR$+"80-Bit-Float:    "+Convert$+#LFCR$+"Windows-R.:   0.72273424781341561117837735264133")

;-------- Beispiel ArcusCotangens(0.75)
ACotT(Var1, Var3)            ;Var3 = ACot(Var1) 
StrT(@Convert$, Var3)        ;liefert fr die Bildschirm-Ausgabe das Ergebnis als String (Convert$)
MessageRequester("Berechnungsbeispiel ACot(0.75)","Single-Float:   "+StrF((#PI/2)-ATan(0.75),20)+#LFCR$+"Double-Float:  "+StrD((#PI/2)-ATan(0.75),20)+#LFCR$+"80-Bit-Float:    "+Convert$+#LFCR$+"Windows-R.:   0.92729521800161223242851246292243")
 
;-------- Beispiel Addition 0.75 + 11.0
AddT(Var1, Var2, Var3)       ;Var3 = Var1 + Var2 
StrT(@Convert$, Var3)        ;liefert fr die Bildschirm-Ausgabe das Ergebnis als String (Convert$)
MessageRequester("Berechnungsbeispiel Addition 0.75+11.0","Single-Float:   "+StrF(0.75+11.0,20)+#LFCR$+"Double-Float:  "+StrD(0.75+11.0,20)+#LFCR$+"80-Bit-Float:    "+Convert$+#LFCR$+"Windows-R.:   11.75")
 
;-------- Beispiel ArcusSinus(0.75)
ASinT(Var1, Var3)            ;Var3 = ASin(Var1) 
StrT(@Convert$, Var3)        ;liefert fr die Bildschirm-Ausgabe das Ergebnis als String (Convert$)
MessageRequester("Berechnungsbeispiel ASin(0.75)","Single-Float:   "+StrF(ASin(0.75),20)+#LFCR$+"Double-Float:  "+StrD(ASin(0.75),20)+#LFCR$+"80-Bit-Float:    "+Convert$+#LFCR$+"Windows-R.:   0.84806207898148100805294433899842")

;-------- Beispiel ArcusTangens(0.75)
ATanT(Var1, Var3)            ;Var3 = ATan(Var1) 
StrT(@Convert$, Var3)        ;liefert fr die Bildschirm-Ausgabe das Ergebnis als String (Convert$)
MessageRequester("Berechnungsbeispiel ATan(0.75)","Single-Float:   "+StrF(ATan(0.75),20)+#LFCR$+"Double-Float:  "+StrD(ATan(0.75),20)+#LFCR$+"80-Bit-Float:    "+Convert$+#LFCR$+"Windows-R.:   0.64350110879328438680280922871732")

;-------- Beispiel Cosinus(0.75)
CosT(Var1, Var3)             ;Var3 = Cos(Var1) 
StrT(@Convert$, Var3)        ;liefert fr die Bildschirm-Ausgabe das Ergebnis als String (Convert$)
MessageRequester("Berechnungsbeispiel Cos(0.75)","Single-Float:   "+StrF(Cos(0.75),20)+#LFCR$+"Double-Float:  "+StrD(Cos(0.75),20)+#LFCR$+"80-Bit-Float:    "+Convert$+#LFCR$+"Windows-R.:   0.73168886887382088631183875300008")

;-------- Beispiel Cotangens(0.75)
CotT(Var1, Var3)             ;Var3 = Cot(Var1) 
StrT(@Convert$, Var3)        ;liefert fr die Bildschirm-Ausgabe das Ergebnis als String (Convert$)
MessageRequester("Berechnungsbeispiel Cot(0.75)","Single-Float:   "+StrF(1/Tan(0.75),20)+#LFCR$+"Double-Float:  "+StrD(1/Tan(0.75),20)+#LFCR$+"80-Bit-Float:    "+Convert$+#LFCR$+"Windows-R.:   1.0734261485493773587431645424435")

;-------- Beispiel Division 0.75 / 11.0
DivT(Var1, Var2, Var3)       ;Var3 = Var1 / Var2 
StrT(@Convert$, Var3)        ;liefert fr die Bildschirm-Ausgabe das Ergebnis als String (Convert$)
MessageRequester("Berechnungsbeispiel Division 0.75/11.0","Single-Float:   "+StrF(0.75/11.0,20)+#LFCR$+"Double-Float:  "+StrD(0.75/11.0,20)+#LFCR$+"80-Bit-Float:    "+Convert$+#LFCR$+"Windows-R.:   0.068181818181818181818181818181818")

;-------- Beispiel Multiplikation 0.75 * 11.0
MulT(Var1, Var2, Var3)       ;Var3 = Var1 * Var2 
StrT(@Convert$, Var3)        ;liefert fr die Bildschirm-Ausgabe das Ergebnis als String (Convert$)
MessageRequester("Berechnungsbeispiel Multiplikation 0.75*11.0","Single-Float:   "+StrF(0.75*11.0,20)+#LFCR$+"Double-Float:  "+StrD(0.75*11.0,20)+#LFCR$+"80-Bit-Float:    "+Convert$+#LFCR$+"Windows-R.:   8.25")

;-------- Beispiel Laden der Konstante Pi als Beispiel fr alle Konstanten (s.Procfpu80.pbi)
PiT(Var3)                    ;Var3 = Pi 
StrT(@Convert$, Var3)        ;liefert fr die Bildschirm-Ausgabe DAS Ergebnis als String (Convert$)
MessageRequester("Beispiel Laden der Konstante Pi","Single-Float:   "+StrF(#PI,20)+#LFCR$+"Double-Float:  "+StrD(#PI,20)+#LFCR$+"80-Bit-Float:    "+Convert$+#LFCR$+"Windows-R.:   3.1415926535897932384626433832795")

;-------- Beispiel Potenzierung 0.75 ^ 11.0
Powt(Var1, Var2, Var3)       ;Var3 = Var1 ^ Var2 
StrT(@Convert$, Var3)        ;liefert fr die Bildschirm-Ausgabe das Ergebnis als String (Convert$)
MessageRequester("Berechnungsbeispiel Potenzierung 0.75^11.0","Single-Float:   "+StrF(Pow(0.75,11.0),20)+#LFCR$+"Double-Float:  "+StrD(Pow(0.75,11.0),20)+#LFCR$+"80-Bit-Float:    "+Convert$+#LFCR$+"Windows-R.:   0.0422351360321044921875")

;-------- Beispiel Sinus(0.75)
SinT(Var1, Var3)             ;Var3 = Sin(Var1) 
StrT(@Convert$, Var3)        ;liefert fr die Bildschirm-Ausgabe das Ergebnis als String (Convert$)
MessageRequester("Berechnungsbeispiel Sin(0.75)","Single-Float:   "+StrF(Sin(0.75),20)+#LFCR$+"Double-Float:  "+StrD(Sin(0.75),20)+#LFCR$+"80-Bit-Float:    "+Convert$+#LFCR$+"Windows-R.:   0.68163876002333416673324195277989")

;-------- Beispiel Quadratwurzel(0.75)
SqrT(Var1, Var3)             ;Var3 = Sqr(Var1) 
StrT(@Convert$, Var3)        ;liefert fr die Bildschirm-Ausgabe das Ergebnis als String (Convert$)
MessageRequester("Berechnungsbeispiel Sqr(0.75)","Single-Float:   "+StrF(Sqr(0.75),20)+#LFCR$+"Double-Float:  "+StrD(Sqr(0.75),20)+#LFCR$+"80-Bit-Float:    "+Convert$+#LFCR$+"Windows-R.:   0.86602540378443864676372317075294")

;-------- Beispiel Subtraktion 0.75 - 11.0
SubT(Var1, Var2, Var3)       ;Var3 = Var1 - Var2 
StrT(@Convert$, Var3)        ;liefert fr die Bildschirm-Ausgabe das Ergebnis als String (Convert$)
MessageRequester("Berechnungsbeispiel Subtraktion 0.75-11.0","Single-Float:   "+StrF(0.75-11.0,20)+#LFCR$+"Double-Float:  "+StrD(0.75-11.0,20)+#LFCR$+"80-Bit-Float:    "+Convert$+#LFCR$+"Windows-R.:   -10.25")

;-------- Beispiel Tangens(0.75)
TanT(Var1, Var3)             ;Var3 = Tan(Var1) 
StrT(@Convert$, Var3)        ;liefert fr die Bildschirm-Ausgabe das Ergebnis als String (Convert$)
MessageRequester("Berechnungsbeispiel Tan(0.75)","Single-Float:   "+StrF(Tan(0.75),20)+#LFCR$+"Double-Float:  "+StrD(Tan(0.75),20)+#LFCR$+"80-Bit-Float:    "+Convert$+#LFCR$+"Windows-R.:   0.93159645994407246116520275657394")

;-------- Beispiel Compare
If CompT(Var1, Var2) = 0
      MessageRequester("Compare","Var1 und Var2 sind gleich")
   ElseIf Compt(Var1, Var2) = 1
      MessageRequester("Compare","Var1 ist kleiner als Var2")
   ElseIf Compt(Var1, Var2) = 2
      MessageRequester("Compare","Var1 ist grsser als Var2")
EndIf 

;-------- Beispiel Copy
CopyT(Var3, Var1)            ;kopiert Var1 in Var3
StrT(@Convert$, Var3)        ;liefert fr die Bildschirm-Ausgabe das Ergebnis als String (Convert$)
MessageRequester("Beispiel fr Copy", "Var3 hat jetzt den Wert " + Convert$)

;-------- Beispiel Change
ChangeT(Var1, Var2)          ;vertauscht Var1 und Var2
StrT(@Convert$, Var1)        ;liefert fr die Bildschirm-Ausgabe das Ergebnis als String (Convert$)
MessageRequester("Beispiel fr Change", "Var1 hat jetzt den Wert " + Convert$)
StrT(@Convert$, Var2)
MessageRequester("Beispiel fr Change", "Var2 hat jetzt den Wert " + Convert$)

;-------- Beispiel Val
Teststring1$ = "0.19e4732"
ValT(@Teststring1$, Var1)
Teststring2$ = "0.11e4932"
ValT(@Teststring2$, Var2)
DivT(Var1, Var2, Var3)       ;Var3 = Var1 / Var2 
StrT(@Convert$, Var3)        ;liefert fr die Bildschirm-Ausgabe das Ergebnis als String (Convert$)
MessageRequester("Beispiel fr Val", "Der Quotient der beiden Teststring-Werte betrgt " + Convert$)

End
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 2
; Folding = -
; EnableAsm
; DisableDebugger